<app-page-header headerTitle="User">
  <app-button icon="fa-solid fa-angle-left" text="Back" (onClick)="goToList()">
  </app-button>
</app-page-header>

<form action="" [formGroup]="userFromData">
  <app-card>
    <div class="row">
      <div class="col-md-3">
        <div class="form-group">
          <label for="Role" class="form-label">Role<span class="text-danger">*</span></label>
          <ng-select appendTo="body" [appendTo]="'body'" autofocus class="custom-ng-select" placeholder="Enter Role"
            formControlName="roleId" [items]="Roles" bindLabel="roleName" bindValue="id" [clearable]="true"
            [searchable]="true" (change)="setRole($event)">
          </ng-select>
          <div *ngIf="submitted && f.roleId.errors?.required" class="alert-error">
            Role is required
          </div>
        </div>
      </div>
      <!-- <div class="col-md-3">
        <div class="form-group">
          <label class="form-label">Salutation<span class="text-danger">*</span></label>
          <ng-select appendTo="body" [items]="salutation" bindLabel="name" bindValue="id" placeholder="--Select--"
            formControlName="salutation"></ng-select>
          <div *ngIf="submitted && f.salutation.errors" class="alert-error">
            <div *ngIf="submitted && f.salutation.errors.required" class="alert-error">Salutation is required</div>
          </div>
        </div>
      </div> -->
      <div class="col-md-3">
        <div class="form-group">
          <label for="name" class="form-label">Name<span class="text-danger">*</span></label>
          <input type="text" class="form-control" id="name" placeholder="Enter Name" formControlName="name" [ngClass]="{
              'is-invalid': (f.name?.touched || submitted) && f.name?.errors
            }" />
          <div *ngIf="submitted && f.name.errors?.required" class="alert-error">
            Name is required
          </div>

        </div>
      </div>
      <div class="col-md-3">
        <div class="form-group">
          <label for="EmailAddress" class="form-label">Email Address<span class="text-danger">*</span></label>
          <input type="email" class="form-control" id="EmailAddress" placeholder="Enter Email Address"
            formControlName="email" title="e.g. abc@gmail.com" [ngClass]="{
            'is-invalid': (f.email?.touched || submitted) && f.email?.errors
          }" />
          <div *ngIf="submitted && f.email.errors?.required" class="alert-error">
            Email is required
          </div>
          <div *ngIf="f.email.errors?.pattern" class="alert-error">
            Please provide valid email
          </div>
        </div>
      </div>
      <div class="col-md-3">
        <div class="form-group">
          <label for="mobile" class="form-label">Mobile<span class="text-danger">*</span></label>
          <input type="text" class="form-control" id="mobile" placeholder="Enter Mobile" formControlName="mobile"
            [ngClass]="{
              'is-invalid': (f.mobile?.touched || submitted) && f.mobile?.errors
            }" />
          <div *ngIf="submitted && f.mobile.errors?.required" class="alert-error">
            Mobile is required
          </div>

        </div>
      </div>
    <!-- </div>
    <div class="row"> -->
      <div class="col-md-3">
        <div class="form-group">
          <label for="pincode" class="form-label">Pincode<span class="text-danger">*</span></label>
          <input type="text" class="form-control" id="pincode" placeholder="Enter Pincode" formControlName="pincode"
            [ngClass]="{
                'is-invalid': (f.pincode?.touched || submitted) && f.pincode?.errors
              }" />
          <div *ngIf="submitted && f.pincode.errors?.required" class="alert-error">
            Pincode is required
          </div>

        </div>
      </div>

      <div class="col-md-3">
        <div class="form-group">
          <label for="address" class="form-label">Address<span class="text-danger">*</span></label>
          <textarea class="form-control" formControlName="address" rows="3"></textarea>
          <!--
          <input type="text" class="form-control" id="address" placeholder="Enter Name" formControlName="address"
            [ngClass]="{
                'is-invalid': (f.address?.touched || submitted) && f.address?.errors
              }" /> -->
          <div *ngIf="submitted && f.address.errors?.required" class="alert-error">
            Address is required
          </div>

        </div>
      </div>
    <!-- </div>



    <div class="row py-2"> -->
      <div class="col-md-3" *ngIf="Id">
        <div class="form-group">
          <app-switch formControlName="isActive" label="Status"></app-switch>
        </div>
      </div>
      <div class="col-md-12" *ngIf="Id && !isView">
        <div class="form-group">
          <app-switch formControlName="isPassword" label="Reset Password"></app-switch>
        </div>
      </div>

      <div class="col-md-3" *ngIf="userFromData.value.isPassword">
        <div class="form-group">
          <label for="Password" class="form-label">Password<span class="text-danger">*</span></label>
          <div class="input-group">
            <input [type]="passwordType" class="form-control" id="Password" placeholder="Password" autocomplete="off"
              formControlName="password" title="Enter valid password" (ngModelChange)="passwordMatch($event)" [ngClass]="{
                'is-invalid':
                  (f.password.touched || submitted) && f.password.errors
              }"  />
            <span class="input-group-text" (click)="togglePassword()">
              <i class="pointer fa fa-eye{{
                  passwordType === 'text' ? '-slash' : ''
                }}"></i>
            </span>
          </div>
          <div *ngIf="submitted && f.password.errors?.required" class="alert-error">
            Password is required
          </div>
          <div *ngIf="f.password.errors?.pattern" class="alert-error">
            Password must be alest 8 character,one small letter,one capital
            letter, one number and special character
          </div>
        </div>
      </div>

      <div class="col-md-3" *ngIf="userFromData.value.isPassword">
        <div class="form-group">
          <label for="ConfirmPassword" class="form-label">Confirm Password<span class="text-danger">*</span></label>
          <input type="password" class="form-control" id="ConfirmPassword" placeholder="Confirm Password"
            formControlName="confirm_password" title="Enter valid password" (input)="passwordMatch($event)" [ngClass]="{
              'is-invalid':
                (f.confirm_password?.touched || submitted) &&
                f.confirm_password?.errors
            }" />
          <div *ngIf="submitted && f.confirm_password.errors?.required" class="alert-error">
            Confirm Password is required
          </div>
          <div *ngIf="showPasswordMatch" class="alert-error">
            Password do not match
          </div>
          <div *ngIf="f.confirm_password?.value && !showPasswordMatch" class="alert-success">
            Password matched successfully
          </div>
        </div>
      </div>
    </div>
  </app-card>
  <div class="text-end m-4">
    <app-button text="Update" (onClick)="onSubmit($event)" [loading]="showLoader" *ngIf="isEdit">
    </app-button>

    <app-button text="Save" (onClick)="onSubmit($event)" [loading]="showLoader" *ngIf="!Id">
    </app-button>
    <app-button text="Cancel" (onClick)="goToList()"> </app-button>
  </div>
</form>
